local sformat = string.format
local tablet = AceLibrary("Tablet-2.0")

DigiCamFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDB-2.0")

DigiCamFu.clickableTooltip = true
DigiCamFu.hasIcon = "Interface\\Icons\\INV_Misc_Spyglass_03"

DigiCamFu:RegisterDB("DigiCamFuDB")
DigiCamFu:RegisterDefaults("profile", {

})

--[[function DigiCamFu:OnInitialize()
end

function DigiCamFu:OnEnable()
end

function DigiCamFu:OnDisable()
end

function DigiCamFu:OnDataUpdate()
end

function DigiCamFu:OnTextUpdate()
	self:SetText("DigiCamFu")
end]]

local function ChangeScreenshotFormat(ssFormat)
	-- Possible formats: tga, jpeg, png
	-- PNG is currently Mac only.
	local newFormat
	
	if ssFormat == "tga" then
		newFormat = "jpeg"
	end

	if ssFormat == "jpeg" then
		if IsMacClient() then
			newFormat = "png"
		else
			newFormat = "tga"
		end
	end

	if ssFormat == "png" then
		newFormat = "tga"
	end

	if newFormat then
		SetCVar("screenshotFormat", newFormat)
	end
end

local function ChangeScreenshotQuality(ssQuality)
	ssQuality = tonumber(ssQuality)
	-- Holt down Alt key to decrease quality
	if IsAltKeyDown() then
		if ssQuality > 0 then
			ssQuality = ssQuality - 1
			SetCVar("screenshotQuality", ssQuality)
		end
	else -- Increase quality
		if ssQuality < 10 then
			ssQuality = ssQuality + 1
			SetCVar("screenshotQuality", ssQuality)
		end
	end
end

function DigiCamFu:OnTooltipUpdate()
	tablet:SetTitle("DigiCamFu")
	tablet:SetHint("Shift-Click to take a screenshot. LeftClick Quality to increase, Alt-LeftClick Quality to decrease.")

	local cat = tablet:AddCategory("columns", 2)
	local ssFormat = GetCVar("screenshotFormat")
	local ssQuality = GetCVar("screenshotQuality")

	cat:AddLine(
		'text', "Image Format",
		'text2', ssFormat,
		'text2R', 1,
		'text2G', 1,
		'text2B', 1,
		'func', ChangeScreenshotFormat,
		'arg1', ssFormat
	)
	cat:AddLine(
		'text', "Image Quality",
		'text2', ssQuality,
		'text2R', 1,
		'text2G', 1,
		'text2B', 1,
		'func', ChangeScreenshotQuality,
		'arg1', ssQuality
	)
end

function DigiCamFu:OnClick()
	if IsShiftKeyDown() and arg1 == "LeftButton" then
		Screenshot()
	end
end
